%if 0%{?fedora} || 0%{?rhel} == 6
%global with_debug 0
%global with_unit_test 1
%else
%global with_debug 0
%global with_unit_test 0
%endif


%global with_bundled 1

%global with_check 0
%global with_devel 0

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define __arch_install_post   /usr/lib/rpm/check-rpaths   /usr/lib/rpm/check-buildroot

%global provider        github
%global provider_tld    com
%global project         github
%global repo            hub
# https://github.com/github/hub
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          88296d1b40efcd2b4edd41e382c1ad2d091a8901
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           hub
Version:        2.2.3
Release:        1%{?dist}
Summary:        hub helps you win at git.
License:        MIT
URL:            https://hub.github.com/
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%if 0%{?rhel} == 7
BuildRequires:	golang15
%endif


Provides:	golang-%{provider}-%{project}-%{repo}

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check} && ! 0%{?with_bundled}
BuildRequires: golang(code.google.com/p/go-netrc/netrc)
BuildRequires: golang(github.com/BurntSushi/toml)
BuildRequires: golang(github.com/bmizerany/assert)
BuildRequires: golang(github.com/fhs/go-netrc/netrc)
BuildRequires: golang(github.com/howeyc/gopass)
BuildRequires: golang(github.com/inconshreveable/go-update)
#BuildRequires: golang(github.com/inconshreveable/go-update/download)
BuildRequires: golang(github.com/jingweno/go-sawyer)
BuildRequires: golang(github.com/jingweno/go-sawyer/hypermedia)
BuildRequires: golang(github.com/jingweno/go-sawyer/mediaheader)
BuildRequires: golang(github.com/jingweno/go-sawyer/mediatype)
BuildRequires: golang(github.com/jtacoma/uritemplates)
BuildRequires: golang(github.com/kardianos/osext)
BuildRequires: golang(github.com/kballard/go-shellquote)
BuildRequires: golang(github.com/kr/binarydist)
BuildRequires: golang(github.com/kr/pretty)
BuildRequires: golang(github.com/kr/text)
BuildRequires: golang(github.com/mattn/go-colorable)
BuildRequires: golang(github.com/mattn/go-isatty)
BuildRequires: golang(github.com/mitchellh/go-homedir)
BuildRequires: golang(github.com/octokit/go-octokit/octokit)
BuildRequires: golang(github.com/ogier/pflag)
BuildRequires: golang(golang.org/x/crypto/ssh/terminal)
BuildRequires: golang(golang.org/x/sys/unix)
BuildRequires: golang(gopkg.in/check.v1)
BuildRequires: golang(gopkg.in/yaml.v1)
%endif


Requires:      golang(code.google.com/p/go-netrc/netrc)
Requires:      golang(github.com/BurntSushi/toml)
Requires:      golang(github.com/bmizerany/assert)
Requires:      golang(github.com/fhs/go-netrc/netrc)
Requires:      golang(github.com/howeyc/gopass)
Requires:      golang(github.com/inconshreveable/go-update)
Requires:      golang(github.com/inconshreveable/go-update/download)
Requires:      golang(github.com/jingweno/go-sawyer)
Requires:      golang(github.com/jingweno/go-sawyer/hypermedia)
Requires:      golang(github.com/jingweno/go-sawyer/mediaheader)
Requires:      golang(github.com/jingweno/go-sawyer/mediatype)
Requires:      golang(github.com/jtacoma/uritemplates)
Requires:      golang(github.com/kardianos/osext)
Requires:      golang(github.com/kballard/go-shellquote)
Requires:      golang(github.com/kr/binarydist)
Requires:      golang(github.com/kr/pretty)
Requires:      golang(github.com/kr/text)
Requires:      golang(github.com/mattn/go-colorable)
Requires:      golang(github.com/mattn/go-isatty)
Requires:      golang(github.com/mitchellh/go-homedir)
Requires:      golang(github.com/octokit/go-octokit/octokit)
Requires:      golang(github.com/ogier/pflag)
Requires:      golang(golang.org/x/crypto/ssh/terminal)
Requires:      golang(golang.org/x/sys/unix)
Requires:      golang(gopkg.in/check.v1)
Requires:      golang(gopkg.in/yaml.v1)

Provides:      golang(%{import_path}/cmd) = %{version}-%{release}
Provides:      golang(%{import_path}/commands) = %{version}-%{release}
Provides:      golang(%{import_path}/fixtures) = %{version}-%{release}
Provides:      golang(%{import_path}/git) = %{version}-%{release}
Provides:      golang(%{import_path}/github) = %{version}-%{release}
Provides:      golang(%{import_path}/ui) = %{version}-%{release}
Provides:      golang(%{import_path}/utils) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/BurntSushi/toml) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/bmizerany/assert) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/bmizerany/assert/vendor/github.com/kr/pretty) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/bmizerany/assert/vendor/github.com/kr/pretty/vendor/github.com/kr/text) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/bmizerany/assert/vendor/github.com/kr/pretty/vendor/github.com/kr/text/colwriter) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/howeyc/gopass) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/howeyc/gopass/vendor/golang.org/x/crypto/ssh/terminal) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/inconshreveable/go-update) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/inconshreveable/go-update/check) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/inconshreveable/go-update/download) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/inconshreveable/go-update/vendor/github.com/kardianos/osext) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/inconshreveable/go-update/vendor/github.com/kr/binarydist) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/kballard/go-shellquote) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/mattn/go-colorable) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/mattn/go-isatty) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/mitchellh/go-homedir) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/octokit) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/fhs/go-netrc/netrc) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/hypermedia) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/mediaheader) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/mediatype) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/vendor/github.com/jtacoma/uritemplates) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/github.com/ogier/pflag) = %{version}-%{release}
Provides:      golang(%{import_path}/vendor/gopkg.in/yaml.v1) = %{version}-%{release}
Provides:      golang(%{import_path}/version) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}
mkdir -p %{buildroot}/%{gopath}/src/github.com/github/hub
cp -pav * %{buildroot}/%{gopath}/src/github.com/github/hub

%build
%if 0%{?rhel} == 7
export GOPATH=%{buildroot}/usr/lib/golang15:$(pwd)/Godeps/_workspade:/usr/lib/golang15
export PATH=/usr/lib/golang15/bin:$PATH
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif
outdir=$(pwd)
pushd %{buildroot}/%{gopath}/src/github.com/github/hub
./script/build -o ${outdir}/hub
popd

%install
install -d -p %{buildroot}/%{_bindir}
install -m 0755 ./hub %{buildroot}/%{_bindir}/hub

# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%gotest %{import_path}/cmd
%gotest %{import_path}/commands
%gotest %{import_path}/git
%gotest %{import_path}/github
%gotest %{import_path}/utils
%gotest %{import_path}/vendor/github.com/BurntSushi/toml
%gotest %{import_path}/vendor/github.com/bmizerany/assert
%gotest %{import_path}/vendor/github.com/bmizerany/assert/vendor/github.com/kr/pretty
%gotest %{import_path}/vendor/github.com/bmizerany/assert/vendor/github.com/kr/pretty/vendor/github.com/kr/text
%gotest %{import_path}/vendor/github.com/bmizerany/assert/vendor/github.com/kr/pretty/vendor/github.com/kr/text/colwriter
%gotest %{import_path}/vendor/github.com/howeyc/gopass/vendor/golang.org/x/crypto/ssh/terminal
%gotest %{import_path}/vendor/github.com/inconshreveable/go-update
%gotest %{import_path}/vendor/github.com/inconshreveable/go-update/vendor/github.com/kardianos/osext
%gotest %{import_path}/vendor/github.com/inconshreveable/go-update/vendor/github.com/kr/binarydist
%gotest %{import_path}/vendor/github.com/kballard/go-shellquote
%gotest %{import_path}/vendor/github.com/mitchellh/go-homedir
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/octokit
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/fhs/go-netrc/netrc
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/hypermedia
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/mediaheader
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/mediatype
%gotest %{import_path}/vendor/github.com/octokit/go-octokit/vendor/github.com/jingweno/go-sawyer/vendor/github.com/jtacoma/uritemplates
%gotest %{import_path}/vendor/github.com/ogier/pflag
%gotest %{import_path}/vendor/gopkg.in/yaml.v1
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%{_bindir}/hub
%license LICENSE
%doc CONTRIBUTING.md README.md

%if 0%{?with_devel}
%files devel -f devel.file-list
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE
%doc CONTRIBUTING.md README.md
%endif

%changelog
* Mon Jul 11 2016 RJ Bergeron <rbergero@gmail.com> - 2.2.3-1
- switch to stable-2.2 branch, cut a 'real' release.

* Fri Jun 24 2016 RJ Bergeron - 0-0.1.git9fc5600
- First package for Fedora

* Fri Jun 24 2016 RJ Bergeron - 0-0.2.git9fc5600
- Try using the supplied libs on el7

* Fri Jun 24 2016 RJ Bergeron - 0-0.3.git9fc5600
- Nope. Okay. Muck with GOPATH.
